<?php
/**
 * Copyright (C) 2019 Futurenext srl
 *
 * This file is part of Zakeke.
 *
 * Zakeke Interactive Product Designer can not be copied and/or distributed
 * without the express permission of Futurenext srl
 *
 * @author    Futurenext srl <help@zakeke.com>
 * @copyright 2019 Futurenext srl
 * @license   https://portal.zakeke.com/Contracts/GeneralConditions
 */

class ZakekeItem extends ObjectModel
{
    /** @var string Zakeke item id */
    public $id_item;

    /** @var string Item preview url */
    public $preview;

    /** @var string Pricing serialized in json format */
    public $pricing_json;

    /**
     * @see ObjectModel::$definition
     */
    public static $definition = array(
        'table'   => 'zakeke_item',
        'primary' => 'id_zakeke_item',
        'fields'  => array(
            'id_item' => array('type' => self::TYPE_STRING, 'required' => true),
            'preview' => array('type' => self::TYPE_STRING, 'required' => true),
            'pricing_json' => array('type' => self::TYPE_STRING, 'required' => true)
        )
    );

    public static function zakekeItemId($id_item)
    {
        if (strpos($id_item, '-') === false) {
            return false;
        }

        return Db::getInstance(_PS_USE_SQL_SLAVE_)->getValue('
		SELECT `id_zakeke_item`
		FROM ' . _DB_PREFIX_ . 'zakeke_item
		WHERE `id_item` = "' . pSQL($id_item) . '"');
    }
}
