<?php
/**
 * Copyright (C) 2019 Futurenext srl
 *
 * This file is part of Zakeke.
 *
 * Zakeke Interactive Product Designer can not be copied and/or distributed
 * without the express permission of Futurenext srl
 *
 * @author    Futurenext srl <help@zakeke.com>
 * @copyright 2019 Futurenext srl
 * @license   https://portal.zakeke.com/Contracts/GeneralConditions
 */

class AdminZakekeController extends ModuleAdminController
{
    public function ajaxProcessInfo()
    {
        $id_zakeke = Tools::getValue('id_zakeke', false);
        if ($id_zakeke === false) {
            $this->errors[] = $this->module->l('id_zakeke is null or empty');
        }

        try {
            /** @var Zakeke $zakeke */
            $zakeke = $this->module;
            $zipUrl = $zakeke->getZakekeApi()->getZakekeOutputZip($id_zakeke);

            $id_zakeke_item = ZakekeItem::zakekeItemId($id_zakeke);
            if ($id_zakeke_item === false) {
                $this->errors[] =$this->module->l('Zakeke item not found');
            }
            $zakeke_item = new ZakekeItem($id_zakeke_item);
        } catch (Exception $e) {
            $this->errors[] = $e->getMessage();
        }

        if (!$this->errors) {
            die(Tools::jsonEncode(array(
                'zipUrl'  => $zipUrl,
                'preview' => $zakeke_item->preview
            )));
        } else {
            die(Tools::jsonEncode(array(
                'hasError' => true,
                'errors' => $this->errors
            )));
        }
    }
}
