/**
 * Copyright (C) 2019 Futurenext srl
 *
 * This file is part of Zakeke.
 *
 * Zakeke Interactive Product Designer can not be copied and/or distributed
 * without the express permission of Futurenext srl
 *
 * @author    Futurenext srl <help@zakeke.com>
 * @copyright 2019 Futurenext srl
 * @license   https://portal.zakeke.com/Contracts/GeneralConditions
 */

document.addEventListener('DOMContentLoaded', function(event) {
    function handleProductCustomization(productCustomizationElement) {
        Array.from(productCustomizationElement.querySelectorAll('.cart_quantity, .cart_delete, .cart_avail, .cart_product, .cart_unit')).forEach(function (element) {
            element.style.opacity = '0';
            element.style.pointerEvents = 'none';
            element.style.border = 'none';
        });

        var nameElement = productCustomizationElement.querySelector('.product-name > a');
        if (nameElement) {
            nameElement.onclick = function (event) {
                event.preventDefault();
            }
        }
    }

    function handleCustomization(zakekeCustomizationElement) {
        var zakekeId = zakekeCustomizationElement.innerText.split(':')[1].trim();
        fetch(window.zakekeInfoUrl + '?id_item=' + zakekeId).then(function (res) {
            return res.json();
        }).then(function (data) {
            if (data.hasError) {
                return;
            }
            var previewImg = document.createElement('IMG');
            previewImg.src = data.preview;
            previewImg.style.display = 'block';
            previewImg.style.maxWidth = '100%';
            zakekeCustomizationElement.appendChild(previewImg);
        });
    }

    function hideInCart() {
        var cartItems = Array.from(document.querySelectorAll('#cart_summary > tbody > tr'));

        var productCustomizationElement = cartItems.find(cartItem => {
            var skuElement = cartItem.querySelector('.cart_ref');
            return skuElement && skuElement.textContent.includes(' product-customization');
        });

        if (productCustomizationElement) {
            handleProductCustomization(productCustomizationElement);
        }

        cartItems.forEach(function (cartItem) {
            var zakekeCustomizationElement = Array.from(cartItem.querySelectorAll('td > ul > li')).find(function (customization) {
                return customization.innerText.includes('-');
            });

            if (zakekeCustomizationElement) {
                handleCustomization(zakekeCustomizationElement);
            }
        });
    }

    hideInCart();
});